/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.jtests.clients.session;

import junit.framework.Test;
import junit.framework.TestSuite;
import javax.rmi.PortableRemoteObject;
import org.objectweb.jonas.jtests.beans.applimet.Appli;
import org.objectweb.jonas.jtests.beans.applimet.AppliHome;
import org.objectweb.jonas.jtests.beans.applimet.Met;
import org.objectweb.jonas.jtests.beans.applimet.MetHome;
import org.objectweb.jonas.jtests.util.JTestCase;


/**
 * testcases specific for stateful session beans
 */
public class F_Applimet extends JTestCase {

    protected static AppliHome applihome = null;
    protected static MetHome methome = null;

    public F_Applimet(String name) {
        super(name);
    }

    protected void setUp() {
        super.setUp();
        useBeans("applimet", true); // must create tables (no entity bean)
    }

    public AppliHome getAppliHome() throws Exception {
        if (applihome == null) {
            applihome = (AppliHome) PortableRemoteObject.narrow(ictx.lookup("AppliBean"), AppliHome.class) ;
        }
        assertTrue(applihome != null);
        return applihome;
    }

    public MetHome getMetHome() throws Exception {
        if (methome == null) {
            methome = (MetHome) PortableRemoteObject.narrow(ictx.lookup("MetBean"), MetHome.class) ;
        }
        assertTrue(methome != null);
        return methome;
    }

    public void testScenario1() throws Exception {
        Met met = getMetHome().create();
        met.methode1();
        met.remove();
    }

    public void testScenario2() throws Exception {
        Appli appli = getAppliHome().create();
        appli.methodeApplicative();
        appli.remove();
    }

    public void testMoscone1() throws Exception {
        Met met = getMetHome().create();
        met.moscone1();
        met.remove();
    }

    public void testMoscone2() throws Exception {
        Met met = getMetHome().create();
        met.getconn();
        met.useconn();
        met.closeconn();
        met.remove();
    }

    public void testMoscone3() throws Exception {
        Met met = getMetHome().create();
        met.getconntx();
        met.useconn();
        met.closeconn();
        met.remove();
    }
    
    public void testRequiresNew() throws Exception {
        Met met = getMetHome().create();
        met.methode2();
        met.remove();
    }

    public void testRollbackOnlyNoTx() throws Exception {
        Appli appli = getAppliHome().create();
        appli.noTxMethod();
        appli.remove();
    }

    public static Test suite() {
        return new TestSuite(F_Applimet.class);
    }


    public static void main (String args[]) throws Exception  {
        String testtorun = null;
        // Get args
        for (int argn = 0; argn < args.length; argn++) {
            String s_arg = args[argn];
            Integer i_arg;
            if (s_arg.equals("-n")) {
                testtorun = args[++argn];
            }
        }
        if (testtorun == null) {
            junit.textui.TestRunner.run(suite());
        } else  {  
            junit.textui.TestRunner.run(new F_Applimet(testtorun));
         }
    }
}
